//this file is part of eMule
//Copyright (C)2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#pragma once

#define ACTION_SETUPL		1
#define ACTION_SETDOWNL		2
#define ACTION_SOURCESL		3
#define ACTION_CON5SEC		4
#define ACTION_CONS			5
#define ACTION_CATSTOP		6
#define ACTION_CATRESUME	7
// Pawcio:: SS Scheduler
#define ACTION_USSMIN		8
#define ACTION_USSMAX		9
#define ACTION_USSPING		10
#define ACTION_USSSURF		11
#define ACTION_USSENABLED	12
#define ACTION_DSSMIN		13
#define ACTION_DSSMAX		14
#define ACTION_DSSPING		15
#define ACTION_DSSSURF		16
#define ACTION_DSSENABLED	17
// Pawcio:: SS Scheduler


#define DAY_DAYLY		0
#define DAY_MO			1
#define DAY_DI			2
#define DAY_MI			3
#define DAY_DO			4
#define DAY_FR			5
#define DAY_SA			6
#define DAY_SO			7
#define DAY_MO_FR		8
#define DAY_MO_SA		9 
#define DAY_SA_SO		10

struct Schedule_Struct{
   CString			title;
   bool				enabled;
   uint8			day;
   uint32			time;
   uint32			time2;
   CString			values[18];//Pawcio: SS Scheduler
   int				actions[18];//Pawcio: SS Scheduler
   void ResetActions()	{for (uint8 index=0;index<18;index++) {actions[index]=0;values[index]="";}}//Pawcio: SS Scheduler
   ~Schedule_Struct() {  }
};

class CScheduler
{
public:
	CScheduler();
	~CScheduler();
	uint8	AddSchedule(Schedule_Struct* schedule);

	void	UpdateSchedule(uint8 index,Schedule_Struct* schedule) {if (index<schedulelist.GetCount())schedulelist.SetAt(index,schedule);}

	Schedule_Struct* GetSchedule(uint8 index) {if (index<schedulelist.GetCount()) return schedulelist.GetAt(index); else return NULL; }
	void	RemoveSchedule(uint8 index);
	void	RemoveAll();
	int		LoadFromFile();
	void	SaveToFile();
	int		Check(bool forcecheck=false);
	uint8	GetCount()		{ return schedulelist.GetCount();}
	void	SaveOriginals();
	void	RestoreOriginals();
	void	ActivateSchedule(uint8 index,bool makedefault=false);
	
	float	original_upload;
	float	original_download;
	uint16	original_connections;
	uint16	original_cons5s;
	uint16	original_sources;
	// Pawcio:: SS Scheduler
	float	original_minup;
	float	original_maxup;
	uint16	original_USSping;
	uint16	original_USSsurf;
	uint16	original_USSEnabled;
	bool	original_USSAutoUp;
	bool	original_USSManualPing;
	float	original_mindown;
	float	original_maxdown;
	uint16	original_DSSping;
	uint16	original_DSSsurf;
	uint16	original_DSSEnabled;
	bool	original_DSSAutoDown;
	bool	original_DSSManualPing;
	// Pawcio:: SS Scheduler
private:
	CArray<Schedule_Struct*,Schedule_Struct*> schedulelist;
	uint8	m_iLastCheckedMinute;
};

